{% extends 'base.html.twig' %}

{% block body %}
<main class='main-content bgc-grey-100'>
    <div id='mainContent'>
    <h2>Cambio Password</h2>

    <form id="form"> <!-- action="{{ url('setNewPassword') }}" method="post" -->
        <div class="alert alert-dismissable alert-danger" id="message" style="display:none"></div>

        <div class="mb-3" id="phase1">
            <label for="password_old" class="control-label">Vecchia password:</label>
            <input type="password" id="password_old" name="password_old" value="" class="form-control"/>
            <br />
            <button class="btn btn-primary" id="phase1SendBt">Controlla</button>
        </div>

        <div class="mb-3" id="phase2" style="display:none">
            <label for="password_new" class="control-label">Nuova password:</label></th>
            <input type="password" id="password_new" name="password_new" class="form-control"/>

            <label for="password_new2" class="control-label">Ripeti la nuova password:</label>
            <input type="password" id="password_new2" name="password_new2" class="form-control"/>

            <br />

            <button type="submit" class="btn btn-primary phase2Btn" id="changePwdBtnAd" name="changePwdBtnAd">Cambia per i Computer</button>
            {% if google %}
            <button type="submit" class="btn btn-primary phase2Btn " id="changePwdBtnGoogle" name="changePwdBtnGoogle">Cambia per Google</button>
            <button type="submit" class="btn btn-primary phase2Btn" id="changePwdBtnAll" name="changePwdBtnAll">Cambia per tutti i servizi</button>
            {% endif %}
        </div>

        <div id="phase3" style="display:none">
            <div class="alert alert-success">Operazione completata con successo!</div>

            <a href="{{ url('homepage') }}" class="btn btn-primary">Torna alla Homepage</a>
        </div>
    </form>
    </div>
</main>
{% endblock %}


{% block javascripts %}
    {{ parent() }}
    <script>
        
        $(function () {
            var $passwordOld = $("#password_old");
            var $passwordNew = $("#password_new");
            var $passwordNew2 = $("#password_new2");
            var $message = $('#message');

            function checkOldPassword() {
                $message.fadeOut();
                $.ajax({
                    type: "POST",
                    url: '{{ force ? path('forceCheckPassword') : path('checkPassword') }}',
                    data: {password: $passwordOld.val()},
                    success: function (response) {
                        if (response.success) {
                            $("#phase2").show('slow');
                            $("#phase1").hide('slow');
                            // $("#username").val(response.username);
                            $passwordOld.prop('disabled', true);
                        } else {
                            $message.fadeIn();
                            $message.html('<ul><li>Password corrente non valida</li></ul>');
                        }
                    }
                })
            }

            $("#phase1SendBt").click(function (e) {
                e.preventDefault();
                checkOldPassword();
            });

            $passwordOld.keyup(function (e) {
                if(e.which === 13) {
                    e.preventDefault();
                    checkOldPassword();
                }
            });


            // function checkSamePassword() {
            //     if ($passwordNew.val() == $passwordNew2.val()) {
            //         $("#pwd").val($passwordNew.val());
            //         $("#phase4").show('slow');
            //         $("#password").val($passwordNew.val());
            //         $passwordNew.prop('disabled', true);
            //         $passwordNew2.prop('disabled', true);
            //     }
            // }

            function checkComplexity() {
                var mediumRegex = new RegExp("^(?=.{7,})(((?=.*[A-Z])(?=.*[a-z]))|((?=.*[A-Z])(?=.*[0-9]))|((?=.*[a-z])(?=.*[0-9]))).*$", "g");
                var message = "";
                var strongRegex = new RegExp("^(?=.{8,})(?=.*[A-Z])(?=.*[a-z])(?=.*[0-9])(?=.*\\W).*$", "g");

                if ($passwordNew.val().length < {{ password.min_char }} ) {
                    message = "<li>Password troppo corta</li>";
                }

                if (mediumRegex.test($passwordNew.val()) === false) {
                    message = message + "<li>Password troppo semplice</li>";
                }

                if ($passwordNew.val() !== $passwordNew2.val()) {
                    message = message + "<li>Le password non coincidono</li>";
                }

                if (message.length > 0) {
                    $message.fadeIn();
                    $message.html('<ul>' + message + '</ul>');
                    return false;
                } else {
                    $message.fadeOut();
                    return true;
                }
            }

            $(".phase2Btn").click(function (e) {
                e.preventDefault();
                if(!checkComplexity()) {
                    return false;
                }

                var targetService = $(this).attr('name').replace("changePwdBtn","");

                $.ajax({
                    type: "POST",
                    url: '{{ force ? path('forceSetNewPassword') : path('setNewPassword') }}',
                    data: {password: $passwordNew.val(), 'targetService': targetService},
                    success: function (response) {
                        if (response.success) {
                            $message.fadeOut();
                            $("#phase3").show('slow');
                            $("#phase2").hide('slow');
                        } else {
                            $message.fadeIn();
                            $message.html('<ul><li>Si è verificato un errore: '+response.error+'</li></ul>');
                        }
                    }
                })
            });

            // $passwordNew.keyup(function () {
            //     if(e.which === 13) {
            //         e.preventDefault();
            //         if(checkComplexity()) {
            //             $form.submit();
            //         }
            //     }
            // });
            //
            // $passwordNew2.keyup(function () {
            //     if(e.which === 13) {
            //         e.preventDefault();
            //         if(checkComplexity()) {
            //             $form.submit();
            //         }
            //     }
            // })
        });
    </script>

{% endblock %}
